/**************************************************************************/
/*  w32sound.c  Version 1.0                                               */
/*  Copyright (C) 2007 Mariano Alvarez Fernandez                          */
/*  Lea en el fichero leeme.txt los detalles                              */
/*  See readme.txt for details                                            */
/**************************************************************************/
/*  Rutinas de sonido para Window, aun no funciona                        */
/**************************************************************************/

//#include <dos.h>        // sound, nosound
#include <mgrx.h>
#include "grsound.h"

static int octava = 3;
static int estacato = 1;
static int son_activo = 1;


int GrSoundIni(void)
{
  son_activo = 1;
}

void GrSoundEnd(void)
{
  son_activo = 0;
}

void GrSoundEnable(void)
{
  son_activo = 1;
}

void GrSoundDisable(void)
{
  son_activo = 0;
}

int GrSoundIsEnabled(void)
{
  return son_activo;
}

int GrSoundSetVolume(int vol)
{
  return 1;
}

int GrSoundSetOctave(int oct)
{
  int oct_ant;

  oct_ant = octava;
  if( oct > 0 && oct < 7 )
    octava = oct;
  return oct_ant;
}

int GrSoundSetEstacato(int est)
{
  int est_ant;

  est_ant = estacato;
  estacato = est;
  return est_ant;
}

void GrSoundPlayMelodia(struct NOTA *mel, int nnotas, int checkstop)
{
  int i;

  for( i=0; i<nnotas; i++){
    GrSoundPlayNote(mel->nota, mel->t);
    mel++;
    if( checkstop && GrEventCheck() ){
      return;
      }
    }
}

void GrSoundPlayNote(int note, int t)
{
  if( note != SILENCIO ){
    GrSoundPlaySound((octava - 1)*12+note, t);
    if( estacato ){
      GrSleep( 10 );
      }
    }
  else{
    GrSleep( t );
    }
}

void GrSoundPlaySound(int numsound, int t)
{
//  static unsigned frecuencia[] = {
//         33,  35,  37,  39,  41,  44,  46,  49,  52,  55,  58,  62,
//         65,  69,  73,  78,  82,  87,  92,  98, 104, 110, 117, 123,
//        131, 139, 147, 156, 165, 175, 185, 196, 208, 220, 233, 247,
//        262, 277, 294, 311, 330, 349, 370, 392, 415, 440, 466, 494,
//        523, 554, 587, 622, 659, 698, 740, 784, 831, 880, 932, 988,
//       1046,1109,1175,1245,1329,1397,1480,1568,1661,1760,1865,1976,
//       2093,2217,2349,2489,2637,2794,2960,3136,3322,3520,3729,3951 };
//
//  if (son_activo) {
//    ((numsound >= 0) && (numsound<84)) ? sound( frecuencia[numsound] ) : nosound();
//    GrSleep(t);
//    nosound();
//  }
//  else {
    GrSleep(t);
//  }
}

